
	.386

	.model flat,stdcall
	option casemap:none

	
	include \masm32\include\windows.inc
	include \masm32\include\user32.inc
	include \masm32\include\kernel32.inc
	includelib \masm32\lib\user32.lib
	includelib \masm32\lib\kernel32.lib

WinMain proto :DWORD,:DWORD,:DWORD,:DWORD

.data
	ClassName  db "SimpleWinClass",0
	AppName    db "Our First Window",0
	OurText    db "Weeeeee Painting",0

.data?
	hInstance    dd ?
	CommandLine  dd ?

.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance, eax
	
	invoke GetCommandLine
	mov    CommandLine, eax
	
	; Call Main Proc, Loop until program exits
	invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
	; Exit Program
	invoke ExitProcess, eax

; Register and Create New Window
WinMain proc hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	
	mov   wc.cbSize,       SIZEOF WNDCLASSEX
	mov   wc.style,        CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc,  OFFSET WndProc ; This is what handles system messages
	mov   wc.cbClsExtra,   NULL
	mov   wc.cbWndExtra,   NULL
	
	push  hInstance
	pop   wc.hInstance
	
	mov   wc.hbrBackground,  COLOR_WINDOW+1
	mov   wc.lpszMenuName,   NULL
	mov   wc.lpszClassName,  OFFSET ClassName
	
	invoke LoadIcon, NULL, IDI_APPLICATION
	mov   wc.hIcon,   eax
	mov   wc.hIconSm, eax
	
	invoke LoadCursor, NULL, IDC_ARROW
	mov   wc.hCursor, eax
	
	; Register Window Class
	invoke RegisterClassEx, addr wc
	; Create new window from Class
	invoke CreateWindowEx,\
		NULL,\                ; Extra Styles. Usually null
		ADDR ClassName,\      ; Window Class Name
		ADDR AppName,\        ; Title bar text
		WS_OVERLAPPEDWINDOW,\ ; Window Apperance Style
		CW_USEDEFAULT,\ ; X Coord window appears on
		CW_USEDEFAULT,\ ; Y Coord
		CW_USEDEFAULT,\ ; Window Width
		CW_USEDEFAULT,\ ; Window Height
		NULL,\  ; Parent Window Handle
		NULL,\  ; Menu Handle
		hInst,\ ; Program Handle
		NULL
	
	; Save Window Handle
	mov hwnd, eax
	; Show Window
	invoke ShowWindow, hwnd, SW_SHOWNORMAL
	; Repaint Window
	invoke UpdateWindow, hwnd
	
	; Message Loop
	.WHILE TRUE
		invoke GetMessage, ADDR msg, NULL, 0, 0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW
	mov     eax,msg.wParam
	ret
WinMain endp

WndPaintTxt proc hWnd:HWND
	LOCAL hdc:HDC
	LOCAL ps:PAINTSTRUCT
	LOCAL rect:RECT
	
	invoke BeginPaint, hWnd, ADDR ps 
	mov hdc, eax 
	invoke GetClientRect, hWnd, ADDR rect 
	invoke DrawText,\  ; Paint Text to Screen
		hdc,\          ; Paint Handle
		ADDR OurText,\ ; String text to draw
		-1,\           ; Number of char to output. -1 if string was null terminated
		ADDR rect,\    ; Pointer to rect struc
		DT_SINGLELINE or DT_CENTER or DT_VCENTER
		
	invoke EndPaint, hWnd, ADDR ps 
WndPaintTxt endp

; Message Handler
WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	; WM_DESTROY = Shut Down Program
	; WM_PAINT = Repainting of the window
	.if uMsg==WM_DESTROY
		invoke PostQuitMessage, NULL
	.elseif uMsg==WM_PAINT
		invoke WndPaintTxt, hWnd
	.else
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam ; Return unproccessed messages
		ret
	.endif
	xor eax, eax
	ret
WndProc endp

end start